﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using Infragistics.Web.UI.GridControls;
using Infragistics.Web.UI.ListControls;
using System.Web.UI.HtmlControls;
using Infragistics.Web.UI;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (Session["GridData"] == null)
        {
            Session["GridData"] = GetEmployees(5);
            WebDataGrid1.DataSource = Session["GridData"];
            WebDataGrid1.DataBind();

            DepartmentDrop.EditorControl.DropDownContainerWidth = 200;

            DepartmentDrop.EditorControl.HeaderTemplate = new HeaderTemplate();
            DepartmentDrop.EditorControl.ItemTemplate = new ItemTemplate();
            DepartmentDrop.EditorControl.DataSource = GetEmployees(5);

        }
        else
        {
            WebDataGrid1.DataSource = Session["GridData"];

            DepartmentDrop.EditorControl.HeaderTemplate = new HeaderTemplate();
            DepartmentDrop.EditorControl.ItemTemplate = new ItemTemplate();

            DepartmentDrop.EditorControl.DataSource = GetEmployees(5);
        }

    }

    private DataTable GetDepartments()
    {
        DataTable dt = new DataTable("Employees");
        dt.Columns.Add("EmployeeID", typeof(int));
        dt.Columns.Add("Name", typeof(string));

        dt.Rows.Add(new object[] { 0, "Jeff"});
        dt.Rows.Add(new object[] { 1, "Mike" });
        dt.Rows.Add(new object[] { 2, "Sue" });
        dt.Rows.Add(new object[] { 3, "Jessica" });

        dt.PrimaryKey = new DataColumn[] { dt.Columns["EmployeeID"] };

        return dt;
    }

    private DataTable GetEmployees(int count)
    {
        DataTable dtData = new DataTable("Employees");

        dtData.Columns.Add("EmployeeID", typeof(int));
        dtData.Columns.Add("Name", typeof(string));
        dtData.Columns.Add("DateOfHire", typeof(DateTime));
        dtData.Columns.Add("Department", typeof(int));


        dtData.Rows.Add(new object[] { 0, "Jeff", DateTime.Today.Date.AddDays(-1 * 0), 0 });
        dtData.Rows.Add(new object[] { 1, "Mike", DateTime.Today.Date.AddDays(-1 * 1), 1 });
        dtData.Rows.Add(new object[] { 2, "Sue", DateTime.Today.Date.AddDays(-1 * 2), 2 });
        dtData.Rows.Add(new object[] { 3, "Jessica", DateTime.Today.Date.AddDays(-1 * 3), 3 });

        dtData.PrimaryKey = new DataColumn[] { dtData.Columns["Department"] };

        return dtData;
    }

    private class HeaderTemplate : ITemplate
    {
        public void InstantiateIn(Control container)
        {
            HtmlTable table = new HtmlTable();
            table.Style.Add(HtmlTextWriterStyle.Height, "20px");
            table.Style.Add(HtmlTextWriterStyle.BackgroundColor, "Grey");
            table.Style.Add(HtmlTextWriterStyle.Color, "White");
            table.Style.Add(HtmlTextWriterStyle.FontSize, "11px");
            table.Style.Add(HtmlTextWriterStyle.FontWeight, "bold");
            table.CellSpacing = 0;
            table.CellPadding = 4;
            HtmlTableRow row = new HtmlTableRow();
            table.Controls.Add(row);

            HtmlTableCell cell = new HtmlTableCell();
            cell.Style.Add(HtmlTextWriterStyle.Width, "100px");
            cell.InnerText = "EmployeeID";
            row.Cells.Add(cell);

            cell = new HtmlTableCell();
            cell.Style.Add(HtmlTextWriterStyle.Width, "100px");
            cell.InnerText = "Name";
            row.Cells.Add(cell);

            container.Controls.Add(table);
        }
    }

    private class ItemTemplate : ITemplate
    {
        public void InstantiateIn(Control container)
        {
            HtmlTable table = new HtmlTable();
            table.CellSpacing = 0;
            table.CellPadding = 4;
            HtmlTableRow row = new HtmlTableRow();
            table.Controls.Add(row);

            HtmlTableCell cell = new HtmlTableCell();
            cell.Style.Add(HtmlTextWriterStyle.Width, "100px");
            TemplateContainer templateContainer = container as TemplateContainer;
            DataRowView dataRow = templateContainer.DataItem as DataRowView;
            cell.InnerText = dataRow["EmployeeID"].ToString();
            row.Cells.Add(cell);

            cell = new HtmlTableCell();
            cell.Style.Add(HtmlTextWriterStyle.Width, "100px");
            templateContainer = container as TemplateContainer;
            dataRow = templateContainer.DataItem as DataRowView;
            cell.InnerText = dataRow["Name"].ToString();
            row.Cells.Add(cell);

            container.Controls.Add(table);
        }
    }


    protected void Button1_Click(object sender, EventArgs e)
    {

    }
}